#!/usr/bin/python
import sqlite3
import sys

class V43dicdata:
	"Class for accessing V43 dictionary data file"
	def __init__(self):
		pass
	
	def __init__(self, engFileName, korFileName):
		self.loadEKDatabase(engFileName)
		self.loadKEDatabase(korFileName)

	def loadEKDatabase(self, fileName):
		try:
			self.ekcon = sqlite3.connect(fileName)
		except:
			print "Error: you must specify database file name."
			return
	
	def loadKEDatabase(self, fileName):
		try:
			self.kecon = sqlite3.connect(fileName)
		except:
			print "Error: you must specify database file name."
			return

	def getHTML(self, entryno, type):
		t = (entryno,)
		if type=="EK":
			cur = self.ekcon.cursor()
			cur.execute("SELECT MainHTML FROM EK WHERE EntryNo=?", t)
		elif type=="KE":
			cur = self.kecon.cursor()
			cur.execute("SELECT MainHTML FROM KE WHERE EntryNo=?", t)
		a= cur.fetchone()
		return a[0]
	
	def getSearchList(self, word, type, count):
		t = (word, count, 0,)
		if type=="EK":
			cur = self.ekcon.cursor()
			cur.execute("SELECT EntryNo, EntrySearch, Offset, Length, Is_audio FROM EK WHERE EntryNo >= (SELECT EntryNo from EK WHERE EntrySearch >= ? limit 1) LIMIT ? OFFSET ?", t)
		elif type=="KE":
			cur = self.kecon.cursor()
			cur.execute("SELECT EntryNo, EntrySearch FROM KE WHERE EntryNo >= (SELECT EntryNo from KE WHERE EntrySearch >= ? limit 1) LIMIT ? OFFSET ?", t)
		else:
			return
		return cur.fetchall()

	def getEntryNoByWord(self, word, type):
		t=(word,)
		if type=="EK":
			cur = self.ekcon.cursor()
			cur.execute("SELECT EntryNo, EntrySearch, Offset, Length, Is_audio FROM EK WHERE EntrySearch = ? LIMIT 1", t)
		elif type=="KE":
			cur = self.kecon.cursor()
			cur.execute("SELECT EntryNo, EntrySearch FROM KE WHERE EntrySearch = ? LIMIT 1", t)
		else:
			return
		return cur.fetchone()
	
	def getEntryNoById(self, id, type):
		t=(id,)
		if type=="EK":
			cur = self.ekcon.cursor()
			cur.execute("SELECT EntryNo, EntrySearch, Offset, Length, Is_audio FROM EK WHERE EntryNo = ?", t)
		elif type=="KE":
			cur = self.kecon.cursor()
			cur.execute("SELECT EntryNo, EntrySearch FROM KE WHERE EntryNo = ?", t)
		else:
			return
		return cur.fetchone()

	def extractAudio (self, offset, length):
		a = open("outfile.dat","rb")
		a.seek(offset)
		b=a.read(length)
		a.close()
		return b

