#!/usr/bin/python
from PyQt4 import QtCore, QtGui
from ui_mainwindow import Ui_MainWindow
from V43dicdata import *

class MainWindow(QtGui.QMainWindow, Ui_MainWindow):
	def __init__(self):
		QtGui.QMainWindow.__init__(self)
		self.setupUi(self)
		self.dic = V43dicdata("dic0.db", "dic1_n.db")
		self.wordmodel = QtGui.QStandardItemModel()
		self.listView.setModel(self.wordmodel)
		self.mode="EK"

	def on_chkEK_toggled(self):
		if self.chkEK.isChecked():
			self.mode="EK"
		else:
			self.mode = "KE"

	def on_chkKE_toggled(self):
		if self.chkKE.isChecked():
			self.mode="KE"
		else:
			self.mode = "EK"

	def on_btnSearch_clicked(self):
		if self.txtQuery.text() == "":
			return
		a=self.dic.getEntryNoByWord(unicode(self.txtQuery.text()),self.mode)
		if not a:
			self.wordBrowser.setHtml("No word found.")
			return
		wordid = int(a[0])
		self.wordBrowser.setHtml(self.dic.getHTML(wordid,self.mode))

	def on_txtQuery_textEdited(self, string):
		self.wordmodel.clear()
		parentitem = self.wordmodel.invisibleRootItem()
		candidates = self.dic.getSearchList(unicode(string), self.mode,20)
		for candidate in candidates:
			i1=QtGui.QStandardItem(QtCore.QString(candidate[1]))
			i2=QtGui.QStandardItem(QtCore.QString.number(candidate[0]))
			parentitem.appendRow([i1, i2])

	def on_listView_clicked(self, index):
		item=self.wordmodel.item(index.row(), 1)
		self.txtQuery.setText(self.wordmodel.itemFromIndex(index).text())

	def on_listView_doubleClicked(self, index):
		item=self.wordmodel.item(index.row(), 1)
		self.wordBrowser.setHtml(self.dic.getHTML(int(item.text()),self.mode))
